public class Token {
    // category of token
    private Tok tokType;
    // line and column location in the file
    private int line, col;
    // lexeme
    private Object value;

    public Token(Tok tokType, int line, int col) {
        this.tokType = tokType;
        this.line = line;
        this.col = col;
    }

    public Token(Tok tokType, int line, int col, Object value) {
        // call basic constructor first
        this(tokType, line, col);
        this.value = value;
    }

    @Override
    public String toString() {
        String toReturn = "(" + this.line + ", " + this.col + ", " +
                this.tokType;
        if (value != null) {
            toReturn += ", " + value.toString();
        }

        return toReturn + ")";
    }
}
